;Kifutplyt reprezentl fnysor. 
;Kls megvilgtstl fgg az erssge.
;Ledek->kifut lmpasor. 
;Fnyert PWMmel kell! 
;500 mikrosec id alatt. 
;Kitltsi tny 16 lpsben vltozhat, fnyertl fggen. 
;Int nyomogombbal be/ki kapcsols. Nem kell pergsment.



; Timer/Counter1-t hasznlom a ledek idztsre, CompareRegA-val, 
; CTC mdban, gy a ledek sebessge vltoztathat lesz kis mdostssal.
; A kell vilgtsi idhz szksges tovbbi lassts.
; Ezt a Timer/Counter0-val fogom megoldani:
; 			
;		1/11 MHz * 65536 * 1024 = 6.5 sec
;
; Teht 6.5 msodpercig vilgthat legfeljebb egy led.
;

;.SET DEBUG =0


;.IFDEF DEBUG
;	.WARNING "Debug engedlyezve van! Mieltt feltltd az eszkzre, kommentezd ki a DEBUG utastst!"
;.ENDIF

;***************************************************************
;* "AVR ExperimentBoard" port assignment information:
;***************************************************************
;*
;* LED0(P):PortC.0          LED4(P):PortC.4
;* LED1(P):PortC.1          LED5(P):PortC.5
;* LED2(S):PortC.2          LED6(S):PortC.6
;* LED3(Z):PortC.3          LED7(Z):PortC.7        INT:PortE.4
;*
;* SW0:PortG.0     SW1:PortG.1     SW2:PortG.4     SW3:PortG.3
;* 
;* BT0:PortE.5     BT1:PortE.6     BT2:PortE.7     BT3:PortB.7
;*
;***************************************************************
;*
;* AIN:PortF.0     NTK:PortF.1    OPTO:PortF.2     POT:PortF.3
;*
;***************************************************************
;*
;* LCD1(VSS) = GND         LCD9(DB2): -
;* LCD2(VDD) = VCC         LCD10(DB3): -
;* LCD3(VO ) = GND         LCD11(DB4): PortA.4
;* LCD4(RS ) = PortA.0     LCD12(DB5): PortA.5
;* LCD5(R/W) = GND         LCD13(DB6): PortA.6
;* LCD6(E  ) = PortA.1     LCD14(007): PortA.7
;* LCD7(DB0) = -           LCD15(BLA): VCC
;* LCD8(DB1) = -           LCD16(BLK): PortB.5 (1=Backlight ON)
;*
;***************************************************************
;.............................................................................................INCLUDE
.include "m128def.inc" ; Definition file for ATmega128 

;.............................................................................................KONSTANSOK
;***********************************
;LEDEK llapotai: O: g. X: nem g
;***********************************
;1. llapot|2. llapot|3. llapot|4. llapot|	   LEDEK
; ---------+----------+----------+----------+   -------------
;	X	X  |  X	  X   |  X   X   |  O   O   |    LD0   LD4
;   X   X  |  X   X   |  O   O   |  X   X   |    LD1   LD5
;   X   X  |  O   O   |  X   X   |  X   X   |    LD2   LD6
;   O   O  |  X   X   |  X   X   |  X   X   |    LD3   LD7
;----------+----------+----------+----------+  --------------
; 10001000 | 01000100 | 00100010 | 00010001 |     76543210
;
;* Konstansok
.equ LEDC0 = 0x00	; Kikapcsolt rendszer llapota
.equ LEDC1 = 0x88 	; Led1 konstans
.equ LEDC2 = 0x44 	; Led2
.equ LEDC3 = 0x22 	; Led3
.equ LEDC4 = 0x11	; Led4
.equ TimerITMaskConstant = 0b10010000 ;Timer Interrupt
.equ comp1AH_const =0xFF
.equ comp1AL_const =0xFF

.equ const =$00 ; Generic Constant Structure example  

;.............................................................................................REGISZTERDEFINCIK
;* Regiszter defincik
.DEF temp 		=r16 ; Temporary Register example
.DEF ledek 		=r17 ; A jelenleg kigyulladt ledek.
.DEF kitteny 	=r18 ; A jelenlegi kitltsi tnyez
.DEF timediv	=r19 ; A fnyer-szablyozshoz szksgses idoszts.
.DEF fenyero	=r21 ; Az rzkeltl rkez fnyer.
.DEF feny2		=r25
.DEF statusz	=r22 ; A rendszer llapotregisztere (NEM A PROCESSZOR!).
					 ; 0. bit: engedelyzve? 1=igen, 0=nem
.DEF ledtemp	=r23 ; Ledek ideiglenes regisztere
.DEF pwmtemp	=r24 ; Mivel a ganj Counter0 PWM mdban b*szott mkdni,
					 ; 	ezrt manulban kell megoldani.
.DEF loop1		=r26
.DEF loop2		=r27
.DEF tmp1		=r28
.DEF tmp2		=r29
.DEF wreg		=r30
;.............................................................................................MEMRIAFOGLALSOK
;*  Memriafoglalsok
.DSEG                		; Adat szegmens kezdete a memriban 
	ledstate0: 	.BYTE 1		; Kikapcsolt ledek llapota
	ledstate1:  .BYTE 1   	; 
	ledstate2:  .BYTE 1  	; reserve tab_size bytes. 
	ledstate3:	.BYTE 1		;
	ledstate4:	.BYTE 1		;

	timerITMask:.BYTE 1		;
	comp1AH:	.BYTE 1		; Memria foglals a OCR1AH rtknek
	comp1AL:	.BYTE 1 	; Memria foglals a OCR1AL rtknek
;.............................................................................................INTERRUPT Vektorok
;*************************************************************** 
;* Reset & Interrupt Vectors  
.cseg 
.org $0000 ; Define start of Code segment 
	jmp RESET ; Reset Handler, jmp is 2 word instruction 

	reti ; INT0 Handler on $0002, dummy 
	nop 
	reti ; INT1 Handler, if INTn used, 'reti' and 'nop' 
	     ; will be replaced by 'jmp INTn_Handler_Address'
	nop 
	reti ; INT2 Handler 
	nop 
	reti ; INT3 Handler 
	nop 
	CALL INT4_IT ; INT4 Handler 
	;nop
	reti ; INT5 Handler 
	nop 
	reti ; INT6 Handler 
	nop 
	reti ; INT7 Handler 
	nop 
	CALL Compare2_IT ; Timer2 Compare Match Handler 
	;nop 
	reti ; Timer2 Overflow Handler 
	nop 
	reti ; Timer1 Capture Event Handler 
	nop 
	CALL Timer1_IT ; Timer1 Compare Match A Handler 
	;nop 
	reti ; Timer1 Compare Match B Handler 
	nop 
	reti ; Timer1 Overflow Handler 
	nop 
	reti ; Timer0 Compare Match Handler 
	nop 
	reti ; Timer0 Overflow Handler 
	nop 
	reti ; SPI Transfer Complete Handler 
	nop 
	reti ; USART0 RX Complete Handler 
	nop 
	reti ; USART0 Data Register Empty Hanlder 
	nop 
	reti ; USART0 TX Complete Handler 
	nop 
	CALL ADConversion_Ready_IT ; ADC Conversion Complete Handler 
	;nop 
	reti ; EEPROM Ready Hanlder 
	nop 
	reti ; Analog Comparator Handler 
	nop 
	reti ; Timer1 Compare Match C Handler 
	nop
	reti ; Timer3 Capture Event Handler 
	nop 
	reti ; Timer3 Compare Match A Handler 
	nop 
	reti ; Timer3 Compare Match B Handler 
	nop 
	reti ; Timer3 Compare Match C Handler 
	nop 
	reti ; Timer3 Overflow Handler 
	nop 
	reti ; USART1 RX Complete Handler 
	nop 
	reti ; USART1 Data Register Empty Hanlder 
	nop 
	reti ; USART1 TX Complete Handler 
	nop 
	reti ; Two-wire Serial Interface Handler 
	nop 
	reti ; Store Program Memory Ready Handler 
	nop 

;.............................................................................................INITIALISATION
;*************************************************************** 
;* MAIN program, Initialisation part
.org $0046;
M_INIT:
RESET: 
;* Stack Pointer init, 
;  Set stack pointer to top of RAM 
	ldi temp, LOW(RAMEND) ; RAMEND = max address in RAM"
	out SPL, temp 	      ; RAMEND value in "m128def.inc" 
	ldi temp, HIGH(RAMEND) 
	out SPH, temp 


;..................................................[Counter1A comp memriba trolsa]
	LDI temp, comp1AL_const ;
	STS comp1AL, temp

	LDI temp, comp1AH_const ;
	STS comp1AH, temp

	LDI temp, TimerITMaskConstant
	STS timerITMask, temp
;..................................................[Konstans ledllapotok memriba trolsa]

	LDI temp, LEDC0		;Kikapcsolt ledllapot memriba mentse
	STS ledstate0, temp 

	LDI temp, LEDC1		; 1. ledllapot regiszterbe
	STS ledstate1, temp	; 1. ledllapot memriba regiszterbl
	
	LDI temp, LEDC2		; 2. ledllapot
	STS ledstate2, temp ; 2. ledllapot memriba regiszterbl
	
	LDI temp, LEDC3		; 3. ledllapot regiszterbe
	STS ledstate3, temp ; 3. ledllapot memriba regiszterbl

	LDI temp, LEDC4		; 4. ledllapot regiszterbe
	STS ledstate4, temp ; 4. ledllapot memriba regiszterbl


;............................................................[Ledek "irnya"(PortC:kimenet)]

	LDI temp, 0xFF		;
	OUT DDRC, temp		; Az sszes led engedlyezse.


;..................................................................[Interrupt engedlyezse]

	SEI 				; Global interrupt engedlyezve.
.IFNDEF DEBUG
	LDI temp,0x10		; INT4 interrupt engedlyez jek
	OUT EIMSK,temp		; INT4 engedlyezve	
.ELSE
	.WARNING "Debug md! Az INT4-es interrupt tiltva."
.ENDIF
	LDS temp, timerITMask ; TimerCompare IT engedlyezs
	OUT TIMSK,temp

;...........................................................................[Counter1 Setup]
;WGM(3:0) = 4 - Clear Timer on Compare to OCR1A
;CS(3:0) = 3
;
;TCCR1A:
;	Compare1A output Mode 		00......
;	Compare1B output Mode		..00....
;	Compare1C output Mode		....00..
;	Waveform Gen Mode (1,0)		......00

;TCCR1B:
;   Input Capture Noise canc	0.......
;   Input Capture Edge select	.0......
;	Waveform Gen Mode (3,2)     ...01...
;	ClockSelect(2:0)			.....011 
;
	LDS temp, comp1AH
	OUT OCR1AH, temp    ; CompareRegister1B Fels bitek belltsa
	LDS temp, comp1AL
	OUT OCR1AL, temp	; CompareRegister1B Als bitek belltsa

.IFDEF DEBUG
	.WARNING "Debug md! Az rajel felgyorstva 12MHz-re."
	LDI temp, 0b00001001
.ELSE
	LDI temp, 0b00001011; Tesztelsi clokra: 00001001. gy gyorsabb a rendszer!
.ENDIF
	OUT TCCR1B, temp	; 


;...........................................................................[Counter2 Setup]
;WGM(3:0) = 4 - Clear Timer on Compare to OCR3A
;CS(3:0) = 3
;
;TCCR0:
;	FOC2				 		0.......
;	WGM20						.1......
;	Compare2 output Mode		..10....
;	Waveform Gen Mode21		    ....0...
;	ClockSelect0(2:0)			.....001
;                               01100001

	LDI temp, 0x44
	OUT OCR2, temp   ; CompareRegister2 belltsa
	LDI temp, 0b01100001
	OUT TCCR2, temp	; 




;.......................................................................[A/D Converter Setup]
;ADMUX
;	REFS(1:0)	11......    Referencia feszltsg (nem kell)
;	ADLAR		..1.....    Balraigazts (gy csak a H biteket kell olvasni)
;	MUX(4:0)	...00010    Analg csatorna kivlasztsa (OPTO kell)
;				11100010

;ADCSR
;	ADEN		1.......	Engedlyezs
;	ADSC		.1......	Egyszeri talakts nem kell neknk
;	ADFR		..1.....	FreeRun, azaz folyamatos talakts
;	ADIF		...0....	Interrupt Flag
;	ADIE		....1...	Interrupt Enable
;	ADPS(2:0)	.....111	128-as oszt elg megfelel neknk elvileg
;				11101111

	LDI temp, 0b11100010
	OUT ADMUX, temp
	LDI temp, 0b11101111
	OUT ADCSR, temp

;.............................................................................................MAIN PROGRAM
;*************************************************************** 
;* MAIN program, Endless loop part
 
CALL Rendszer_engedelyez
JMP LedBekapcs

M_LOOP: 

;< Insert your program code Here>
	SBRS statusz,0
	JMP M_LOOP
	SBRS pwmtemp, 0
	JMP LedKikapcs
	JMP LedBekapcs

jmp M_LOOP ; Endless Loop  


;..............................................................................................SZUBRUTINOK
;*************************************************************** 
;* Subroutins, Interrupt routins
LedBekapcs:
	LDI temp, 0xFF
	OUT DDRC, temp
	OUT PORTC,ledek
	JMP M_LOOP

LedKikapcs:
	LDI temp, 0x00
	OUT DDRC, temp
	JMP M_LOOP


Rendszer_letilt:
	MOV pwmtemp, feny2
	LDS ledek, ledstate0; Ledek kikapcsolsa.
	LDI statusz, 0x00 	; 0. bit 0-ra lltva --> rendszer letiltva.
	OUT TIMSK, statusz	; TimerIT-k lelltsa
	RETI 				; Visszatrs

Rendszer_engedelyez:
	MOV	feny2, pwmtemp
	LDS ledek, ledstate1; Ledek bekapcsolsa 1-es llapotba
	LDI statusz, 0x11	; 0. bit 1-re lltva --> rendszer engedlyezve
	LDS ledtemp, timerITMask ;TimerIT visszalltsa
	OUT TIMSK, ledtemp
	RETI				; Visszatrs

;Vlts!
Timer1_IT:
	JMP SetNextLedState_Alternate
;	JMP SetNextLedState_Alternate
	RETI

;Fnymrs ksz
ADConversion_Ready_IT:
	IN fenyero, ADCH
	CALL SetPWM_Width
	RETI

;INT gomb lekezelse
INT4_IT:
	CALL Delay200ms
	SBRS statusz,0
	JMP Rendszer_engedelyez
	JMP Rendszer_letilt	
	;RETI


; Belltja a kvetkez ledllapotot.
;Elsdleges mdszer, ha ez beszarik, ott a msodlagos.
;-----------------------------------------------------------------
SetNextLedState:			; Lehetsges llapotok: 1,2,3,4
	LDS ledtemp, ledstate1	
	CPSE ledtemp, ledek		;Ha az 1. llapot az, betltjk a 2.-t
	JMP NotState1			;Ha nem, akkor ugrunk a kvetkezre
	LDS ledek, ledstate2	;s gy tovbb
	RETI ;Timer1_IT

NotState1:					; Lehetsges llapotok: 2,3,4
	LDS ledtemp, ledstate2
	CPSE ledtemp, ledek
	JMP NotState2
	LDS ledek, ledstate3
	RETI ;Timer1_IT

NotState2:					; Lehetsges llapotok: 3,4
	LDS ledtemp, ledstate3
	CPSE ledtemp, ledek
	JMP NotState3
	LDS ledek, ledstate4
	RETI ;Timer1_IT

NotState3:					; Lehetsges llapotok: 4
	LDS ledek, ledstate1
	RETI ;Timer1_IT
;----------------------------------------------------


;Alternatv LedSor vltoztat, ha az els befuccsolna.
;---------------------------------------------------
SetNextLedState_Alternate:
	LDI ledtemp, 0b00010001
	CPSE ledtemp, ledek
	JMP ShiftLedRight
	LDI ledek, 0b10001000
	RETI ;Timer1_IT

ShiftLedRight:
	LSR ledek
	RETI ;Timer1_IT
;------------------------------------------------------


;A mrt fnyert tltjk be a kompartorba, gy, mivel 
; invertl PWM-ben vagyunk minl kisebb rtket ad az 
; A/D konverter, annl hosszabb ideig fog vilgtani a
; LED.
;-----------------------------------------------------
SetPWM_Width:
	OUT OCR2, fenyero
	RET
;-----------------------------------------------------	


; Fzishelyes PWM mdban vagyunk, azaz
; 	ahol nagyobb a szmll rtke a komp-szintnl, ott
;   pwntemp=1.
; Ezzel a megoldssal: Minl kisebb a komparlsi rtk,
; 	annl hosszabb ideig fog pwntemp 1 lenni.
; A szmll oda-vissza szmol ciklikusan
; Fel, le, fel, le...
;-----------------------------------------------------
Compare2_IT:
	SBRS pwmtemp, 0
	JMP SetPWM_High
	JMP SetPWM_Low
;	RETI

SetPWM_High:
	LDI pwmtemp, 0xFF
	RETI ;Compare2_IT

SetPWM_Low:
	LDI pwmtemp, 0x00
	RETI ;Compare2_IT
;-----------------------------------------------------

Delay4ms:
	ldi	tmp1,0x39 ;OK
Loop1:	ldi	wreg,0x00
Loop2:	dec	wreg
	brne	loop2 
	dec	tmp1
	brne	loop1
	ret
;**************************
;****
;**** Delay 1 sec
;****
;**************************
Delay200ms:
	ldi	tmp2,50	; Delay for about 1 sec for the LCD to start
Longdelay_Loop:
	rcall	delay4ms
	dec	tmp2
	brne	LongDelay_Loop
	ret

